QGIS Application - Bug report #17320
Can't filter a table by a date field
2017-10-23 04:47 AM - Patrick Dunford

Status: Closed
Priority: Normal
Assignee:

Category: Vectors

Affected QGIS version:2.18.13
Operating System:

Pull Request or Patch supplied:
Crashes QGIS or corrupls data:

Regression?: No
Easy fix?: No
Resolution: no timely feedback

Copied to github as #: 25218

Description

| have a shapefile whose data table has a field that contains dates and is shown in the layer properties as being QDateTime type.

If | try to filter the table by entering a date constant the OGR provider keeps throwing error messages and refusing to apply the filter.

There is no documentation anywhere that | can find that documents how to specify a date value to a filter and trying some of the common

SQL ones like quote marks or # characters have failed.

History

#1 - 2017-10-23 08:46 AM - Giovanni Manghi
- Category changed from GUI to Vectors
- Status changed from Open to Feedback

Please attach sample data.

#2 - 2017-10-24 08:44 AM - Patrick Dunford

https://drive.google.com/open?id=0B3nXs7dryndWeWVmbXFocWEycjQ

#3 - 2017-10-24 11:41 AM - Giovanni Manghi

- Operating System deleted (Debian 9.1)

- Status changed from Feedback to Open

- Affected QGIS version changed from master to 2.18.13

This (example) works

cast(date as character) = '1938/02/04'

taken from

https:/gis.stackexchange.com/a/100050

#4 - 2017-10-25 05:01 AM - Patrick Dunford
https://drive.google.com/open?id=0B3nXs7drynJWeWVmbXFocWEycjQ
https://gis.stackexchange.com/a/100050

That seems to do the trick. However it is an issue on masters | have tested with, do you have any suggestion it is relevant to a particular version of master?

Can this be added to the official documentation as | did search for it but did not find a solution such as this.. How is this documentation produced.

#5 - 2017-10-25 10:21 AM - Harrissou Santanna

Patrick Dunford wrote:

Can this be added to the official documentation as I did search for it but did not find a solution such as this.. How is this documentation produced.

Patrick, the documentation source is at www.github.com/qgis/QGIS-Documentation and, from each html doc page you have a link at the bottom to directly

access its source file and propose the changes you want. Guidelines to write docs are accessible at
http://docs.qgis.org/testing/en/docs/documentation guidelines/index.html. And of course all these information are available in the QGIS main website.

That said, there are some information at http://docs.qgis.org/testing/en/docs/user manual/working with vector/expression.html#date-and-time-functions

(I don't know if it would have solved your problem, though). | recall that Alexandre made a lot of tests with these field types before writing it. If you wanna

complete/improve it, you are of course welcome...

#6 - 2017-10-25 10:34 AM - Giovanni Manghi

Harrissou Santanna wrote:

Patrick Dunford wrote:

Can this be added to the official documentation as I did search for it but did not find a solution such as this.. How is this documentation produced.

Patrick, the documentation source is at www.github.com/qqis/QGIS-Documentation and, from each html doc page you have a link at the bottom to

directly access its source file and propose the changes you want. Guidelines to write docs are accessible at
http.//docs.qqis.org/testing/en/docs/documentation _guidelines/index.html. And of course all these information are available in the QGIS main

website.

That said, there are some information at

http.//docs.qqis.org/testing/en/docs/user_manual/working_with_vector/expression.html#date-and-time-functions (I don't know if it would have solved

your problem, though). I recall that Alexandre made a lot of tests with these field types before writing it. If you wanna complete/improve it, you are of

course welcome...

| agree that a patch/contribution to docs would be good. | am anyway wondering if this is not really a bug, in the sense that in case of real date fields the

above workaround should be applied by QGIS filter in a transparent way(?). Opinions?

#7 - 2017-10-25 10:41 AM - Harrissou Santanna

Giovanni Manghi wrote:

I am anyway wondering if this is not really a bug, in the sense that in case of real date fields the above workaround should be applied by QGIS filter

in a transparent way(?). Opinions?

Agreed, field type should be enough to QGIS to handle data transparently and do these basic operations.
People should not have to cast it unless they wish to do some other particular process, not easily compatible with the field type.

#8 - 2019-01-21 12:34 AM - Jiirgen Fischer
- Status changed from Open to Feedback

Please test with QGIS 3.4 - QGIS 2.18 reached it's end of life.

#9 - 2019-02-24 01:07 AM - Giovanni Manghi
- Resolution set to no timely feedback
- Status changed from Feedback to Closed
